# Fetching a list of Project Accounting Records

Returns all project accounting records (Baseline, Earned Value, Earned Value Forecasting,
Forecasting,  and Recognition), unless filter parameters have been applied.


This endpoint returns structured Project Accounting Records objects.
As with all Kantata OX API endpoints, the returned data will be referenced in sorted order in the results array
and will be indexed by ID in the project_accounting_records top-level JSON key.
Please see our Response Format section for more information.

Endpoint: GET /project_accounting_records
Version: 1.0.0

## Query parameters:

  - `created_at` (string)
    Filters for records created on or after the specified date (e.g. GET /api/v1/project_accounting_records.json?created_at=2014-02-25). The datetime must be in ISO 8601 format.

  - `end_date` (string)
    Filters for records with accounting periods that end on specified dates.

You can filter for records with an accounting period that ends...
* within a date range, with a pair of semicolon-separated dates (e.g. 2019-09-14;2019-09-15),
* on or _after_ a date, with only the date before the semicolon (e.g. 2019-09-14;),
* on or _before_ a date, with only the date after the semicolon (e.g. ;2019-09-14). The date must be in ISO 8601 format.

  - `external_reference_external_message` (string)
    Filter the objects based on the external message of their associated external references. This is an exact match.

  - `external_reference_external_status` (string)
    Filter by the status of the external object in the external system.

  - `external_reference_service_model` (string)
    Filter by the type of the external object this external reference belongs to.

  - `external_reference_service_model_ref` (integer)
    Filter by the id of the external object this external reference belongs to.

  - `external_reference_service_model_refs` (string)
    Filter for objects that correlate to the specified external object IDs. Provide a comma-separated list of up to 200 external IDs.

  - `external_reference_service_name` (string)
    Filter by the name of the provider for integration.

  - `external_reference_status` (string)
    Filter by the status of the integration, this can be successful or fail.

  - `has_external_references` (boolean)
    Filter by whether or not the object has external references.

  - `ids` (array)
    Filters for records with the specified IDs. Give multiple record IDs
            in a comma-separated list (e.g. GET /api/v1/project_accounting_records.json?ids=55,16,73).

  - `include` (string)
    Any of the below associations can be included in your request by providing the include param, e.g. include=association1,association2.
- external_references (ExternalReference) - Includes references to external integrations for this object.
- role (Role) - Includes the ID of the role associated with the record.
- story (Story) - Includes the ID of the task related to the record.
- user (User) - Includes the ID(s) of user(s) associated with the record
                    (e.g. who created the record, who the record was created for, etc.).
- workspace (Workspace) - Includes the ID of the project the record belongs to.

  - `only` (string)
    Allows you to request one or more resources directly by ID. Multiple IDs can be supplied
in a comma separated list, like GET /api/v1/workspaces.json?only=5,6,7.

  - `page` (integer)

  - `per_page` (integer)

  - `show_deleted` (boolean)
    If true, returns only deleted project accounting records. Set to false by default.

  - `start_date` (string)
    Filters for records with accounting periods that begin on specified dates.

You can filter for records with an accounting period that begins...
* within a date range, with a pair of semicolon-separated dates (e.g. 2019-09-14;2019-09-15),
* on or _after_ a date, with only the date before the semicolon (e.g. 2019-09-14;),
* on or _before_ a date, with only the date after the semicolon (e.g. ;2019-09-14). The date must be in ISO 8601 format.

  - `status` (array)
    Filters for records with the specified status.

Valid values: Draft, Pending Approval, Approved, Cancelled.

Note: Records without a status cannot be returned with this filter.

  - `type` (string)
    Only includes Project Accounting Records of the specified type.
                    Valid values: Baseline, Earned Value, Earned Value Forecasting, Forecasting, Recognition.

  - `user_id` (integer)
    Only includes Project Accounting Records for the specified user_id.

  - `without_external_reference_service_name` (string)
    Exclude by the existence of an external reference with the specified service name.

  - `workspace_ids` (array)
    Filters for records from projects with the specified IDs. Give multiple project IDs
            in a comma-separated list (e.g. GET /api/v1/project_accounting_records.json?workspace_ids=25344,76545).

## Response 200 fields (application/json):

  - `count` (integer)

  - `meta` (object)

  - `meta.count` (integer)

  - `meta.page_count` (integer)

  - `meta.page_number` (integer)

  - `meta.page_size` (integer)

  - `results` (array)

  - `results.key` (string)

  - `results.id` (string)

  - `project_accounting_records` (object)

  - `external_references` (object)

  - `workspaces` (object)

  - `stories` (object)

  - `roles` (object)

  - `users` (object)

## Response 400 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)


